Index: trunk/SophyaLib/SkyMap/localmap.h
===================================================================
--- trunk/SophyaLib/SkyMap/localmap.h	(revision 1419)
+++ trunk/SophyaLib/SkyMap/localmap.h	(revision 1423)
@@ -186,10 +186,10 @@
 ////////////////////////////////////////////////////////////////
 // Surcharge d'operateurs A (+,-,*,/) (T) x
-/*! \ingroup LocalMap \fn operator+(const LocalMap<T>&,T)
+/*! \ingroup SkyMap \fn operator+(const LocalMap<T>&,T)
   \brief Operator LocalMap = LocalMap + constant */
 template <class T> inline LocalMap<T> operator + (const LocalMap<T>& a, T b)
     {LocalMap<T> result; result.CloneOrShare(a); result.SetTemp(true); 
     result.Add(b); return result;}
-/*! \ingroup LocalMap \fn operator+(T,const LocalMap<T>&)
+/*! \ingroup SkyMap \fn operator+(T,const LocalMap<T>&)
   \brief Operator LocalMap = constant + LocalMap */
 template <class T> inline LocalMap<T> operator + (T b,const LocalMap<T>& a)
@@ -198,5 +198,5 @@
 
 
-/*! \ingroup LocalMap\fn operator-(const LocalMap<T>&,T)
+/*! \ingroup SkyMap\fn operator-(const LocalMap<T>&,T)
   \brief Operator LocalMap = LocalMap - constant */
 template <class T> inline LocalMap<T> operator - (const LocalMap<T>& a, T b)
@@ -210,5 +210,5 @@
     result.Sub(b,true); return result;}
 
-/*! \ingroup LocalMap \fn operator*(const LocalMap<T>&,T)
+/*! \ingroup SkyMap \fn operator*(const LocalMap<T>&,T)
   \brief Operator LocalMap = LocalMap * constant */
 template <class T> inline LocalMap<T> operator * (const LocalMap<T>& a, T b)
@@ -216,5 +216,5 @@
     result.Mul(b); return result;}
 
-/*! \ingroup LocalMap \fn operator*(T,const LocalMap<T>&)
+/*! \ingroup SkyMap \fn operator*(T,const LocalMap<T>&)
   \brief Operator LocalMap = constant * LocalMap */
 template <class T> inline LocalMap<T> operator * (T b,const LocalMap<T>& a)
@@ -222,5 +222,5 @@
     result.Mul(b); return result;}
 
-/*! \ingroup LocalMap \fn operator/(const LocalMap<T>&,T)
+/*! \ingroup SkyMap \fn operator/(const LocalMap<T>&,T)
   \brief Operator LocalMap = LocalMap / constant */
 template <class T> inline LocalMap<T> operator / (const LocalMap<T>& a, T b)
@@ -228,5 +228,5 @@
     result.Div(b); return result;}
 
-/*! \ingroup LocalMap \fn operator/(T,const LocalMap<T>&)
+/*! \ingroup SkyMap \fn operator/(T,const LocalMap<T>&)
   \brief Operator LocalMap = constant / LocalMap  */
 template <class T> inline LocalMap<T> operator / (T b, const LocalMap<T>& a)
@@ -237,5 +237,5 @@
 // Surcharge d'operateurs C = A (+,-) B
 
-/*! \ingroup LocalMap \fn operator+(const LocalMap<T>&,const LocalMap<T>&)
+/*! \ingroup SkyMap \fn operator+(const LocalMap<T>&,const LocalMap<T>&)
   \brief Operator LocalMap = LocalMap + LocalMap */
 template <class T>
@@ -246,5 +246,5 @@
     return result; }
 
-/*! \ingroup LocalMap \fn operator-(const LocalMap<T>&,const LocalMap<T>&)
+/*! \ingroup SkyMap \fn operator-(const LocalMap<T>&,const LocalMap<T>&)
   \brief Operator LocalMap = LocalMap - LocalMap */
 template <class T>
Index: trunk/SophyaLib/SkyMap/spherehealpix.h
===================================================================
--- trunk/SophyaLib/SkyMap/spherehealpix.h	(revision 1419)
+++ trunk/SophyaLib/SkyMap/spherehealpix.h	(revision 1423)
@@ -209,10 +209,10 @@
 ////////////////////////////////////////////////////////////////
 // Surcharge d'operateurs A (+,-,*,/) (T) x
-/*! \ingroup SphereHEALPix \fn operator+(const SphereHEALPix<T>&,T)
+/*! \ingroup SkyMap \fn operator+(const SphereHEALPix<T>&,T)
   \brief Operator SphereHEALPix = SphereHEALPix + constant */
 template <class T> inline SphereHEALPix<T> operator + (const SphereHEALPix<T>& a, T b)
     {SphereHEALPix<T> result; result.CloneOrShare(a); result.SetTemp(true); 
     result.Add(b); return result;}
-/*! \ingroup SphereHEALPix \fn operator+(T,const SphereHEALPix<T>&)
+/*! \ingroup SkyMap \fn operator+(T,const SphereHEALPix<T>&)
   \brief Operator SphereHEALPix = constant + SphereHEALPix */
 template <class T> inline SphereHEALPix<T> operator + (T b,const SphereHEALPix<T>& a)
@@ -233,5 +233,5 @@
     result.Sub(b,true); return result;}
 
-/*! \ingroup SphereHEALPix \fn operator*(const SphereHEALPix<T>&,T)
+/*! \ingroup SkyMap \fn operator*(const SphereHEALPix<T>&,T)
   \brief Operator SphereHEALPix = SphereHEALPix * constant */
 template <class T> inline SphereHEALPix<T> operator * (const SphereHEALPix<T>& a, T b)
@@ -239,5 +239,5 @@
     result.Mul(b); return result;}
 
-/*! \ingroup SphereHEALPix \fn operator*(T,const SphereHEALPix<T>&)
+/*! \ingroup SkyMap \fn operator*(T,const SphereHEALPix<T>&)
   \brief Operator SphereHEALPix = constant * SphereHEALPix */
 template <class T> inline SphereHEALPix<T> operator * (T b,const SphereHEALPix<T>& a)
@@ -245,5 +245,5 @@
     result.Mul(b); return result;}
 
-/*! \ingroup SphereHEALPix \fn operator/(const SphereHEALPix<T>&,T)
+/*! \ingroup SkyMap \fn operator/(const SphereHEALPix<T>&,T)
   \brief Operator SphereHEALPix = SphereHEALPix / constant */
 template <class T> inline SphereHEALPix<T> operator / (const SphereHEALPix<T>& a, T b)
@@ -251,5 +251,5 @@
     result.Div(b); return result;}
 
-/*! \ingroup SphereHEALPix \fn operator/(T,const SphereHEALPix<T>&)
+/*! \ingroup SkyMap \fn operator/(T,const SphereHEALPix<T>&)
   \brief Operator SphereHEALPix = constant / SphereHEALPix  */
 template <class T> inline SphereHEALPix<T> operator / (T b, const SphereHEALPix<T>& a)
@@ -260,5 +260,5 @@
 // Surcharge d'operateurs C = A (+,-) B
 
-/*! \ingroup SphereHEALPix \fn operator+(const SphereHEALPix<T>&,const SphereHEALPix<T>&)
+/*! \ingroup SkyMap \fn operator+(const SphereHEALPix<T>&,const SphereHEALPix<T>&)
   \brief Operator SphereHEALPix = SphereHEALPix + SphereHEALPix */
 template <class T>
@@ -269,5 +269,5 @@
     return result; }
 
-/*! \ingroup SphereHEALPix \fn operator-(const SphereHEALPix<T>&,const SphereHEALPix<T>&)
+/*! \ingroup SkyMap \fn operator-(const SphereHEALPix<T>&,const SphereHEALPix<T>&)
   \brief Operator SphereHEALPix = SphereHEALPix - SphereHEALPix */
 template <class T>
Index: trunk/SophyaLib/SkyMap/spherethetaphi.h
===================================================================
--- trunk/SophyaLib/SkyMap/spherethetaphi.h	(revision 1419)
+++ trunk/SophyaLib/SkyMap/spherethetaphi.h	(revision 1423)
@@ -263,10 +263,10 @@
 ////////////////////////////////////////////////////////////////
 // Surcharge d'operateurs A (+,-,*,/) (T) x
-/*! \ingroup SphereThetaPhi \fn operator+(const SphereThetaPhi<T>&,T)
+/*! \ingroup SkyMap \fn operator+(const SphereThetaPhi<T>&,T)
   \brief Operator SphereThetaPhi = SphereThetaPhi + constant */
 template <class T> inline SphereThetaPhi<T> operator + (const SphereThetaPhi<T>& a, T b)
     {SphereThetaPhi<T> result; result.CloneOrShare(a); result.SetTemp(true); 
     result.Add(b); return result;}
-/*! \ingroup SphereThetaPhi \fn operator+(T,const SphereThetaPhi<T>&)
+/*! \ingroup SkyMap \fn operator+(T,const SphereThetaPhi<T>&)
   \brief Operator SphereThetaPhi = constant + SphereThetaPhi */
 template <class T> inline SphereThetaPhi<T> operator + (T b,const SphereThetaPhi<T>& a)
@@ -287,5 +287,5 @@
     result.Sub(b,true); return result;}
 
-/*! \ingroup SphereThetaPhi \fn operator*(const SphereThetaPhi<T>&,T)
+/*! \ingroup SkyMap \fn operator*(const SphereThetaPhi<T>&,T)
   \brief Operator SphereThetaPhi = SphereThetaPhi * constant */
 template <class T> inline SphereThetaPhi<T> operator * (const SphereThetaPhi<T>& a, T b)
@@ -293,5 +293,5 @@
     result.Mul(b); return result;}
 
-/*! \ingroup SphereThetaPhi \fn operator*(T,const SphereThetaPhi<T>&)
+/*! \ingroup SkyMap \fn operator*(T,const SphereThetaPhi<T>&)
   \brief Operator SphereThetaPhi = constant * SphereThetaPhi */
 template <class T> inline SphereThetaPhi<T> operator * (T b,const SphereThetaPhi<T>& a)
@@ -299,5 +299,5 @@
     result.Mul(b); return result;}
 
-/*! \ingroup SphereThetaPhi \fn operator/(const SphereThetaPhi<T>&,T)
+/*! \ingroup SkyMap \fn operator/(const SphereThetaPhi<T>&,T)
   \brief Operator SphereThetaPhi = SphereThetaPhi / constant */
 template <class T> inline SphereThetaPhi<T> operator / (const SphereThetaPhi<T>& a, T b)
@@ -305,5 +305,5 @@
     result.Div(b); return result;}
 
-/*! \ingroup SphereThetaPhi \fn operator/(T,const SphereThetaPhi<T>&)
+/*! \ingroup SkyMap \fn operator/(T,const SphereThetaPhi<T>&)
   \brief Operator SphereThetaPhi = constant / SphereThetaPhi  */
 template <class T> inline SphereThetaPhi<T> operator / (T b, const SphereThetaPhi<T>& a)
@@ -314,5 +314,5 @@
 // Surcharge d'operateurs C = A (+,-) B
 
-/*! \ingroup SphereThetaPhi \fn operator+(const SphereThetaPhi<T>&,const SphereThetaPhi<T>&)
+/*! \ingroup SkyMap \fn operator+(const SphereThetaPhi<T>&,const SphereThetaPhi<T>&)
   \brief Operator SphereThetaPhi = SphereThetaPhi + SphereThetaPhi */
 template <class T>
@@ -323,5 +323,5 @@
     return result; }
 
-/*! \ingroup SphereThetaPhi \fn operator-(const SphereThetaPhi<T>&,const SphereThetaPhi<T>&)
+/*! \ingroup SkyMap \fn operator-(const SphereThetaPhi<T>&,const SphereThetaPhi<T>&)
   \brief Operator SphereThetaPhi = SphereThetaPhi - SphereThetaPhi */
 template <class T>