Index: trunk/SophyaLib/Manual/defsophya.sty
===================================================================
--- trunk/SophyaLib/Manual/defsophya.sty	(revision 1433)
+++ trunk/SophyaLib/Manual/defsophya.sty	(revision 1434)
@@ -34,5 +34,5 @@
 {
 \vspace{1cm}
-\makebox[160mm][c]{\includegraphics[width=6cm]{blue_sophya_400.eps}}
+\makebox[160mm][c]{\includegraphics[width=8cm]{blue_sophya_400.eps}}
 % \hspace{7mm} \raisebox{6mm}{\rule{100 mm}{0.5 mm} }
 % \makebox[40 mm]{\bf Sophya }
@@ -75,5 +75,5 @@
 \vfill
 \hfill 
-\framebox[\textwidth]{\hspace{0.5cm} \bf Sophya Note  #1
+\framebox[\textwidth]{\hspace{0.5cm} \bf Sophya Note  #1 (V1.1)
 \hspace{1cm} \today } \\
 }
Index: trunk/SophyaLib/Manual/sophya.tex
===================================================================
--- trunk/SophyaLib/Manual/sophya.tex	(revision 1433)
+++ trunk/SophyaLib/Manual/sophya.tex	(revision 1434)
@@ -53,12 +53,16 @@
 We have decided to use as much as possible available 
 numerical analysis libraries, encapsulating them whenever
-possible.
-  
-  The SOPHYA design and implementation has been carried out
-with the specific goal of providing the general framework for
-the Planck-HFI data processing software. However, most of the 
-packages presented here have a more general scope than the CMB analysis
-and Planck mission problem.
-  The source directory tree 
+possible. Although some the modules in SOPHYA have been 
+designed with the specific goal of providing the general framework for
+the Planck-HFI data processing software, most of the
+packages presented here have a more general scope than the 
+CMB analysis and Planck mission problem. This documents
+presents only a brief overview of the class library, 
+mainly from the user's point of view. A more complete description
+can be found in the reference manual, available from our
+web site: \\ 
+{\bf http://www.sophya.org}. 
+
+The source directory tree 
 \footnote{ CVS: cvsserver.lal.in2p3.fr:/exp/eros/CVSPlanck} 
 is organised into a number of modules. 
@@ -104,5 +108,5 @@
 \item[] {\bf PrgUtil/} Various utility programs (runcxx, scanppf, scanfits, \ldots)
 \item[] {\bf PMixer/} skymixer and related programs
-\item[] {\bf ProgPI/}  interactive analysis tool - It should be noted that 
+\item[] {\bf ProgPI/} interactive analysis tool - It should be noted that 
 this module uses the SOPHYA class library and is based on {\bf PI}
 which is a C++ library defining a complete GUI program 
@@ -115,4 +119,11 @@
 \end{itemize}   
 
+Modules containing examples and demo programs:
+\begin{itemize}
+\item[] {\bf Examples/} Sample SOPHYA codes and example programs and
+makefiles (auto\_makefile and ex\_makefile).
+\item[] {\bf DemoPIApp/} Sample exripts and programs for (s)piapp 
+interactive analysis tools.
+\end{itemize}   
 \newpage 
 
@@ -120,5 +131,5 @@
 Basic usage of Sophya classes are described in in the following sections.
 Complete Sophya documentation can be found at our web site: \\
-{\bf http://hfi-l2.in2p3.fr}. 
+{\bf http://www.sophya.org}. 
 
 \subsection{Environment variables}
@@ -168,14 +179,11 @@
 {\tt trivial.cc }.
 \begin{verbatim}
-csh> cp \$DPCBASEREP/Include/makefile_auto makefile
+csh> cp Examples/auto_makefile makefile
+csh> cp Examples/ex1.cc trivial.cc
 csh> make trivial
 \end{verbatim}
 This command should compile the {\tt trivial.cc} file, 
-and link it against the sophya libraries. The object and executable 
-file names are: \\ 
-{\tt \$HOME/`uname`-\$EROSCXX/Objs/trivial.o} \\
-{\tt \$HOME/`uname`-\$EROSCXX/Exec/trivial}.
-\par 
-The file {\tt \$DPCBASEREP/Include/makefile\_example} provides another 
+and link it against the sophya libraries. 
+The file {\tt \$DPCBASEREP/Include/ex\_makefile} provides another 
 example makefile.
 
@@ -190,5 +198,5 @@
 \begin{verbatim}
 csh> runcxx -h
-SOPHYA Version  0.9 Revision 97 (V_Oct2000) -- Nov  9 2000 16:20:52 cxx
+SOPHYA Version  1.1 Revision 0 (V_Fev2001) -- Feb 28 2001 11:19:17 cxx
  runcxx : compiling and running of a piece of C++ code
    Usage: runcxx [-compopt CompileOptions] [-linkopt LinkOptions]